#line 1 ".\Src\main.c"
#line 1 "C:\Sonix\SN8_C_~1.140\C\include\SonixDef.h"



unsigned long GetRollingCode(unsigned int offset);








struct _intrinsicbitfield
{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};













#line 1 ".\Src\main.c"
#line 1 ".\Include\FC2720.h"


#line 6 ".\Include\FC2720.h"








struct bitRegister{
	unsigned bit0:1;
	unsigned bit1:1;
	unsigned bit2:1;
	unsigned bit3:1;
	unsigned bit4:1;
	unsigned bit5:1;
	unsigned bit6:1;
	unsigned bit7:1;
};

typedef unsigned char BYTE;
typedef unsigned long WORD;
typedef double DWORD;






sfr	R = 0x82;
sfr	Z = 0x83;
sfr	Y = 0x84;
sfr	PFLAG = 0x86;

sbit	LVDF =0x86:5;















 sfr    TM1M    =0XA0;
 sfr    TM1C   =0XA1;
 sfr    TM1D0   =0XA2;
 sfr    TM1D1  =0XA3;
 sfr    TM1D2  =0XA4;
 sfr    TM1D3  =0XA5;
 sfr    PWM1E   =0XA6;

 sfr	I2CCON	=0XA8;
 sfr	I2CADD	=0XA9;
 sfr	I2CBUF	=0XAA;

 sfr    TM2M    =0XB0;
 sfr    TM2C   =0XB1;
 sfr    TM2D0   =0XB2;
 sfr    TM2D1  =0XB3;
 sfr    TM2D2  =0XB4;
 sfr    TM2D3  =0XB5;
 sfr    PWM2E   =0XB6;


 sfr    E2PCON =0Xab;
 sfr    E2PDB  =0Xac;
 sfr    E2PADL =0Xad;
 sfr    E2ADH  =0Xae;

 sfr    TKCON=  0X88;
 sfr    TKTMD =0X89;
 sfr    TKTMCH =0X8B;
 sfr    TKTMCL =0X8C;
 sfr    TKTMRH =0X8D;
 sfr    TKTMRL =0X8E;
 sfr    TKMIO  =0X8F;

 sfr    ADM =0XB9;
 sfr    ADB =0XBa;
 sfr    ADR =0XBb;
 sfr    ADT =0XBc;
 sfr    VREFH =0XBd;
 sfr    ADPCON =0XBe;
 sfr	PEDGE =0XBF;

 sfr    P1W = 0XC0;
 sfr	P1M = 0xc1;
 sfr	P3M=0XC3;
 sfr    INTRQ1 = 0XC6;
 sfr    INTEN1 = 0XC7;
 sfr    INTRQ = 0XC8;
 sfr    INTEN = 0XC9;
 sfr	OSCM = 0xca;
 sfr	RCADJ =0XCB;
 sfr	WDTR =0XCC;
 sfr    OPTION = 0XCD;
 sfr	PCL =0XCE;
 sfr	PCH =0XCF;

 sfr	P1 = 0XD1;
 sfr	P2 = 0XD2;
 sfr	P3 = 0XD3;
 sfr	T0M = 0XD8;
 sfr	T0C = 0XD9;
 sfr    OPA1CON = 0XDA;
 sfr    OPA2CON = 0XDB;
 sfr    P1OD = 0XDC;
 sfr    P3W = 0XDE;
 sfr    STKP = 0XDF;

 sfr	P1UR=0Xe1;
 sfr	P2UR=0XE2;
 sfr	P3UR=0XE3;

 sfr	P1PD=0XEC;
 sfr	P3PD=0XEE;

sbit	FP37UR = 0XE3:7;

sbit	E2P_ER_HALF =0xAB:5;
sbit	E2P_BER	    =0xAB:4;
sbit	E2P_CER	    =0xAB:3;
sbit	E2P_SER		=0xAA:2;
sbit	E2P_PG		=0xA9:1;
sbit	E2P_RD		=0xA8:0;

sbit	SPIEN		=0x98:0;

sbit	WCOL		=0x99:1;
sbit	CSEN		=0x99:2;
sbit	MLS		=0x99:3;
sbit	CKEG		=0x99:4;
sbit	CKPOLB		=0x99:5;


sbit	I2CEN		=0xA8:0;
sbit	I2CPU		=0xA8:1;
sbit	I2CCKP		=0xA8:2;
sbit	TXAK		=0xA8:3;
sbit	SRW		=0xA8:4;
sbit	HBB		=0xA8:5;
sbit	HAAS		=0xA8:6;
sbit	HCF		=0xA8:7;



sbit	WDTP0		=0xCD:0;
sbit	WDTP1		=0xCD:1;
sbit	WDTP2		=0xCD:2;
sbit	RTCCON		=0xCD:3;
sbit	LVDTEN		=0xCD:4;
sbit	LDOEN		=0xCD:5;
sbit	LIRC_EN		=0xCD:6;
sbit	RCADJEN		=0xCD:7;




sbit	FCHS0		=0xB9:0;
sbit	FCHS1		=0xB9:1;
sbit	FCHS2		=0xB9:2;
sbit	FCHS3		=0xB9:3;
sbit	FGCHS		=0xB9:4;
sbit	FEOC		=0xB9:5;
sbit	FADS		=0xB9:6;
sbit	FADENB		=0xB9:7;



sbit	FADCKS0		=0xBB:4;
sbit	FADCKS1		=0xBB:6;



sbit	FADT_0		=0xBc:0;
sbit	FADT_1		=0xBC:1;
sbit	FADT_2		=0xBC:2;
sbit	FADT_3		=0xBC:3;
sbit	FADT_4		=0xBC:4;

sbit	Fadts_0		=0xBC:6;
sbit	Fadts_1		=0xBC:7;


sbit	FVHS0		=0xBD:0;
sbit	FVHS1		=0xBD:1;

sbit	FEVHENB		=0xBD:7;






sbit	FINT0IE		=0xc9:0;
sbit	FINT1IE		=0xc9:1;
sbit	FTM0IE		=0xc9:2;
sbit	FTM1IE		=0xc9:3;
sbit	FTM2IE		=0xc9:4;
sbit	FRPIE		=0xc9:5;
sbit	FI2CIE		=0xc9:6;
sbit	FADCIE		=0xc9:7;

sbit	FE2PIE		=0xc7:0;
sbit	FTKTMRIE	=0xc7:1;
sbit	FSPIIE		=0xc7:2;
sbit	FT0IE	    =0xC7:3;
sbit	FOPAIE    	=0xC7:4;

sbit	FINT0IF		=0xc8:0;
sbit	FINT1IF		=0xc8:1;
sbit	FTM0IF		=0xc8:2;
sbit	FTM1IF		=0xc8:3;
sbit	FTM2IF		=0xc8:4;
sbit	FRPIF		=0xc8:5;
sbit	FI2CIF		=0xc8:6;
sbit	FADCIF		=0xc8:7;

sbit	FE2PIF		=0xc6:0;
sbit	FTKTMRIF	=0xc6:1;
sbit	FSPIIF		=0xc6:2;
sbit	FT0IF	    =0xC6:3;
sbit	FOPAIF    	=0xC6:4;


sbit	FGIE = 0xdf:7;


sbit	FP17 = 0xd1:7;
sbit	FP16 = 0xd1:6;
sbit	FP15 = 0xd1:5;
sbit	FP14 = 0xd1:4;
sbit	FP13 = 0xd1:3;
sbit	FP12 = 0xd1:2;
sbit	FP11 = 0xd1:1;
sbit	FP10 = 0xd1:0;


sbit	FP37 = 0xd3:7;
sbit	FP36 = 0xd3:6;
sbit	FP35 = 0xd3:5;
sbit	FP34 = 0xd3:4;
sbit	FP33 = 0xd3:3;
sbit	FP32 = 0xd3:2;
sbit	FP31 = 0xd3:1;
sbit	FP30 = 0xd3:0;













#line 2 ".\Src\main.c"


























































 unsigned char DigTable[13]=
{
  0X3F,
  0X06,
  0X5B,
  0X4F,
  0X66,
  0X6D,
  0X7D,
  0X07,
  0X7F,
  0X6F,
  0X00,
  0X40,
  0X73,
};
bit       bit250us=0;
bit       bit1ms=0;
bit       bit10ms=0;
bit       bit50ms=0;

bit       bitToggle=0;
bit       bitGetAdFinish=0;
bit       bitDP1=1;
bit       bitDP2=1;

 unsigned char u8DigShow1=8;
 unsigned char u8DigShow2=8;
 unsigned char u8DigShow3=8;

 unsigned char u8Codetmp1=0xFF;
 unsigned char u8Codetmp2=0xFF;
 unsigned char u8Codetmp3=0xFF;

 unsigned char u8DigShow1Now=0;
 unsigned char u8DigShow2Now=0;
 unsigned char u8DigShow3Now=0;

 unsigned long int u16AdcFilterValue=0;
 unsigned long int  voltageNow=0;




void display_ctr(void);
void system_init(void);
void get_voltage(void);

void t0_enable(void);
void adc_init(void);


#line 119 ".\Src\main.c"
void __interrupt[0x8] isr(void)
{
    static unsigned char j=0;
  if(FT0IF)
  {


    T0C=68;
    j++;
    bit250us=1;










    if(j>39)
    {
      j=0;
      bit10ms=1;
    }






    FT0IF=0;

  }
}

#line 162 ".\Src\main.c"
void main(void)
{


	adc_init();
	t0_enable();





    while(1)
    {
      if(bit250us)
      {
        bit250us=0;
        display_ctr();
      }






      if(bit10ms)
      {
        bit10ms=0;
        WDTR=0x5A;
        get_voltage();
      }
	}
}

#line 202 ".\Src\main.c"
void adc_init(void)
{

  ADPCON=0x40;
  ADR=0x00;
  VREFH=0x00;
  ADM  =0x96;
}

#line 217 ".\Src\main.c"
void all_com_in(void)
{
 P3M &=~ 0x01;
 P1M &=~ 0x04;
 P3M &=~ 0x04;
 P3M &=~ 0x08;
 P3M &=~ 0x10;
 P3M &=~ 0x20;
}


#line 236 ".\Src\main.c"
void com1_enable(void)
{
 P3 |= 0x01;
 P3M |= 0x01;
}
void com2_enable(void)
{
 P1 |= 0x04;
 P1M |= 0x04;
}
void com3_enable(void)
{
 P3 |= 0x04;
 P3M |= 0x04;
}
void com4_enable(void)
{
 P3 |= 0x08;
 P3M |= 0x08;
}
void com5_enable(void)
{
 P3 |= 0x10;
 P3M |= 0x10;
}

void com6_enable(void)
{
 P3 |= 0x20;
 P3M |= 0x20;
}

void display_ctr(void)
{
  static unsigned char u8DisplayDriveStep=0;
  static unsigned long int x=0;

  u8Codetmp1=DigTable[u8DigShow1];
  u8Codetmp2=DigTable[u8DigShow2];
  u8Codetmp3=DigTable[u8DigShow3];

  if(x<6000)
  {
    x++;


  }
  else
  {
	u8DigShow1=u8DigShow1Now;
	u8DigShow2=u8DigShow2Now;
    u8DigShow3=u8DigShow3Now;


    if(u16AdcFilterValue<1280)
    {

	  bitDP2=0;
	  bitDP1=1;
    }
    else
    {
	  bitDP1=0;
	  bitDP2=1;
    }
  }

  all_com_in();
  switch(u8DisplayDriveStep)
  {
    case 0:
    {
      if(u8Codetmp1& 0x01)
      {
 P3 &=~ 0x04;
 P3M |= 0x04;
        com2_enable();
      }
    }
    break;

    case 1:
    {
      if(u8Codetmp1& 0x02)
      {
 P3 &=~ 0x08;
 P3M |= 0x08;
        com2_enable();
      }
    }
    break;

    case 2:
    {
      if(u8Codetmp1& 0x04)
      {
 P1 &=~ 0x04;
 P1M |= 0x04;
        com5_enable();
      }
    }
    break;

    case 3:
    {
      if(u8Codetmp1& 0x08)
      {
 P3 &=~ 0x20;
 P3M |= 0x20;
        com2_enable();
      }
    }
    break;


    case 4:
    {
      if(u8Codetmp1& 0x10)
      {
 P3 &=~ 0x10;
 P3M |= 0x10;
        com2_enable();
      }
    }
    break;


    case 5:
    {
      if(u8Codetmp1& 0x20)
      {
 P1 &=~ 0x04;
 P1M |= 0x04;
        com3_enable();
      }
    }
    break;

    case 6:
    {
      if(u8Codetmp1& 0x40)
      {
 P1 &=~ 0x04;
 P1M |= 0x04;
        com4_enable();
      }
    }
    break;

    case 7:
    {
      if(bitDP1)
      {
 P3 &=~ 0x01;
 P3M |= 0x01;
        com2_enable();
      }
    }
    break;

    case 8:
    {

      if(u8Codetmp2& 0x01)
      {
 P3 &=~ 0x08;
 P3M |= 0x08;
        com5_enable();
      }
    }
    break;

    case 9:
    {
      if(u8Codetmp2& 0x02)
      {
 P3 &=~ 0x10;
 P3M |= 0x10;
        com3_enable();
      }
    }
    break;

    case 10:
    {
      if(u8Codetmp2& 0x04)
      {
 P3 &=~ 0x10;
 P3M |= 0x10;
        com4_enable();
      }
    }
    break;

    case 11:
    {
      if(u8Codetmp2& 0x08)
      {
 P3 &=~ 0x08;
 P3M |= 0x08;
        com3_enable();
      }
    }
    break;

    case 12:
    {
      if(u8Codetmp2& 0x10)
      {
 P3 &=~ 0x04;
 P3M |= 0x04;
        com6_enable();
      }
    }
    break;

    case 13:
    {
      if(u8Codetmp2& 0x20)
      {
 P3 &=~ 0x04;
 P3M |= 0x04;
        com4_enable();
      }
    }
    break;

    case 14:
    {
      if(u8Codetmp2& 0x40)
      {
 P3 &=~ 0x04;
 P3M |= 0x04;
        com5_enable();
      }
    }
    break;

    case 15:
    {
      if(bitDP2)
      {
 P3 &=~ 0x01;
 P3M |= 0x01;
        com3_enable();
      }
    }
    break;

    case 16:
    {
      if(u8Codetmp3& 0x01)
      {
 P3 &=~ 0x20;
 P3M |= 0x20;
        com1_enable();
      }
    }
    break;

    case 17:
    {
      if(u8Codetmp3& 0x02)
      {
 P3 &=~ 0x20;
 P3M |= 0x20;
        com3_enable();
      }
    }
    break;

    case 18:
    {
      if(u8Codetmp3& 0x04)
      {
 P3 &=~ 0x20;
 P3M |= 0x20;
        com5_enable();
      }
    }
    break;

    case 19:
    {
      if(u8Codetmp3& 0x08)
      {
 P3 &=~ 0x08;
 P3M |= 0x08;
        com6_enable();
      }
    }
    break;

    case 20:
    {
      if(u8Codetmp3& 0x10)
      {
 P3 &=~ 0x20;
 P3M |= 0x20;
        com4_enable();
      }
    }
    break;

    case 21:
    {
      if(u8Codetmp3& 0x20)
      {
 P3 &=~ 0x10;
 P3M |= 0x10;
        com6_enable();
      }
    }
    break;

    case 22:
    {
      if(u8Codetmp3& 0x40)
      {
 P3 &=~ 0x10;
 P3M |= 0x10;
        com1_enable();
      }
    }
    break;
  }
  u8DisplayDriveStep++;
  if(u8DisplayDriveStep>22)
  u8DisplayDriveStep=0;
}

#line 574 ".\Src\main.c"















#line 604 ".\Src\main.c"




#line 615 ".\Src\main.c"
void get_voltage(void)
{
  static unsigned char cnt=0;
  static unsigned char count=0;
  static unsigned long int u16AdcNow=0;
  static unsigned long int max=0;
  static unsigned long int min=0;
  static unsigned long int minddle=0;


  u16AdcNow=ADB;
  u16AdcNow<<=4;
  u16AdcNow+=(ADR&0x0F);

  if(bitGetAdFinish)
  {
    bitGetAdFinish=0;
    if(u16AdcFilterValue<1280)
	{

      voltageNow=25*u16AdcFilterValue;

	  voltageNow=voltageNow>>5;
	}
	else
	{
      voltageNow=10*u16AdcFilterValue;

	  voltageNow=voltageNow>>7;
	}
    u8DigShow1Now =voltageNow/100;
    u8DigShow2Now =voltageNow%100/10;
    u8DigShow3Now =voltageNow%10;
  }


  if(u16AdcFilterValue!=u16AdcNow)
  {
    cnt++;
    if(cnt>42)
    {
	  count++;
	  if(count>2)
	  count=0;
	  switch(count)
	  {
	    case 0:
        max=u16AdcNow;
		min=u16AdcNow;
		break;

		case 1:
        if(u16AdcNow>max)
		max=u16AdcNow;

        if(min>u16AdcNow)
		min=u16AdcNow;
		break;

		case 2:
        if(max<u16AdcNow)
		u16AdcNow=max;

		if(u16AdcNow<min)
		u16AdcNow=min;
	    cnt=0;
        bitGetAdFinish=1;
	    u16AdcFilterValue=u16AdcNow;
		break;
	  }
    }
  }
  else
  {
    cnt=0;
  }
  FADS =1;
}

#line 701 ".\Src\main.c"
void t0_enable(void)
{
  T0M=0xD0;

  FT0IE=1;
  FGIE=1;
}

#line 716 ".\Src\main.c"

#line 732 ".\Src\main.c"

#line 740 ".\Src\main.c"
void system_init(void)
{



























}

